<template>
  <a-select
    show-search
    label-in-value
    :value="name"
    placeholder="请输入名称搜索"
    style="width: 100%"
    :filter-option="false"
    :not-found-content="fetching ? undefined : null"
    @search="fetchUser"
    @change="handleChange"
    allowClear
  >
    <a-spin v-if="fetching" slot="notFoundContent" size="small" />
    <a-select-option v-for="item in data" :key="item.promoActiveSn" :value="item.promoActiveSn">
      {{ item.name }}
    </a-select-option>
  </a-select>
</template>
<script>
import debounce from 'lodash/debounce'
import { promoActiveList } from '@/api/promoActive'
export default {
  props: {
  },
  data () {
    this.lastFetchId = 0
    this.fetchUser = debounce(this.fetchUser, 800)
    return {
      data: [],
      name: [],
      fetching: false
    }
  },
  methods: {
    fetchUser (name) {
      console.log('fetching user', name)
      if (name == '') return
      this.lastFetchId += 1
      const fetchId = this.lastFetchId
      this.data = []
      this.fetching = true
      promoActiveList({ 'name': name, pageNo: 1, pageSize: 20 }).then(res => {
        if (fetchId !== this.lastFetchId) {
          return
        }
        this.data = res.data && res.data.list ? res.data.list : []
        this.fetching = false
      })
    },
    handleChange (value) {
      Object.assign(this, {
        name: value,
        data: [],
        fetching: false
      })
      this.$emit('change', value || { key: undefined })
    },
    resetForm () {
      this.name = []
    }
  }
}
</script>
